"""J.A.R.V.I.S. Modlog Cog Utilities."""
from dis_snek.models.discord.embed import Embed, EmbedField
from dis_snek.models.discord.guild import AuditLogEntry
from dis_snek.models.discord.user import Member

from jarvis.utils import build_embed


def modlog_embed(
    member: Member,
    admin: Member,
    log: AuditLogEntry,
    title: str,
    desc: str,
) -> Embed:
    """Get modlog embed."""
    fields = [
        EmbedField(
            name="Moderator",
            value=f"{admin.mention} ({admin.username}#{admin.discriminator})",
        ),
    ]
    if log.reason:
        fields.append(EmbedField(name="Reason", value=log.reason, inline=False))
    embed = build_embed(
        title=title,
        description=desc,
        color="#fc9e3f",
        fields=fields,
        timestamp=log.created_at,
    )
    embed.set_author(name=f"{member.username}", icon_url=member.display_avatar.url)
    embed.set_footer(text=f"{member.username}#{member.discriminator} | {member.id}")
    return embed
